/*
	Slimp : Slimp Light and Intelligent Media Player.
	Copyright (C) 2009 Guillaume Royer <groyer.perso@gmail.com>

	This file is a part of Slimp.
	
	Slimp is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	Slimp is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Slimp; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	*/

#include<gtk/gtk.h>
#include<gst/gst.h>
#include<glib.h>
#include<glib/gi18n.h>
#include"slimp.h"
#include"slimp_include.h"
void slimp_menu_quit(GtkMenuItem* item, gpointer data){
	slimp_leave(NULL, NULL, data);
	return;
}

void slimp_menu_open(GtkMenuItem* item, gpointer data){
	GtkWidget* dialog;
	Slimp* slimp;
	gchar* filename;
	slimp = (Slimp*) data;
	dialog = gtk_file_chooser_dialog_new("Open file", GTK_WINDOW(slimp->main_window), GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT){
		filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		slimp_open(filename, slimp);
	}
	gtk_widget_destroy (dialog);
	return;
}

void slimp_menu_about(GtkMenuItem* item, gpointer data){
	return;
}

void menu_add_widget(GtkUIManager* uiManager, GtkWidget* widget, GtkContainer* box){
  gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
  return;
}

SlimpMenu* create_menu(Slimp* slimp){
	static SlimpMenu self;
	
	self.box = gtk_hbox_new(TRUE, 0);

	GtkUIManager* ui_manager = gtk_ui_manager_new();
	gtk_ui_manager_add_ui_from_file(ui_manager, SLIMP_DATA_DIR "/menu.xml", NULL);
	g_signal_connect(G_OBJECT(ui_manager), "add_widget", G_CALLBACK(menu_add_widget), self.box);
	
	GtkActionGroup* action_group = gtk_action_group_new("menuActionGroup");
	GtkActionEntry entries[] = {
	{"FileMenuAction",	NULL, 		"_File",	"<Alt>F",	NULL,	NULL	},
	{"OpenAction",		GTK_STOCK_OPEN,	"_Open",	"",		NULL,	G_CALLBACK(slimp_menu_open)},
	{"QuitAction",		GTK_STOCK_QUIT,	"_Quit",	"",		NULL,	G_CALLBACK(slimp_menu_quit)},
	{"HelpMenuAction",	NULL,		"_Help",	"<Alt>H",	NULL,	NULL	},
	{"AboutAction",		GTK_STOCK_ABOUT,"_About",	NULL,		NULL,	G_CALLBACK(slimp_menu_about)}
	};
	gtk_action_group_add_actions(action_group, entries, G_N_ELEMENTS(entries), slimp);
	
	gtk_ui_manager_insert_action_group(ui_manager, action_group, 0);
	return &self;
}
