/*
	Slimp : Slimp Light and Intelligent Media Player.
	Copyright (C) 2009 Guillaume Royer <groyer.perso@gmail.com>

	This file is a part of Slimp.
	
	Slimp is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	Slimp is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Slimp; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	*/

#include<gtk/gtk.h>
#include<gst/gst.h>
#include<glib.h>
#include<glib/gi18n.h>
#include"slimp.h"
#include"slimp_include.h"

SlimpPlayer *create_player(Slimp *slimp){
	static SlimpPlayer self;
	
	
	//Create scale bar
	self.adjustment = gtk_adjustment_new(0, 0, 0, 0, 0, 0);
	self.scale = gtk_hscale_new(GTK_ADJUSTMENT(self.adjustment)); //With a null adjustment, cause it depends on the song to play.
	gtk_scale_set_draw_value(GTK_SCALE(self.scale), FALSE);
	self.scale_lock = 0;
	
	//Create button "Play"
	self.button = gtk_button_new();
	self.button_label = gtk_label_new("");
	gtk_label_set_text(GTK_LABEL(self.button_label), _("Play"));
	self.time_label = gtk_label_new("");
	gtk_label_set_text(GTK_LABEL(self.time_label), "0:00 / 0:00");
	g_signal_connect(G_OBJECT(self.button), "clicked", G_CALLBACK(slimp_playing), slimp);
	
	self.volume_button = gtk_volume_button_new();
	gtk_scale_button_set_value(self.volume_button,50);
	g_signal_connect(G_OBJECT(self.volume_button), "value-changed", G_CALLBACK(slimp_playing_volume), slimp);
	
	self.status_bar = gtk_statusbar_new();
	self.status_bar_id =  gtk_statusbar_get_context_id(self.status_bar, "Playing");
        gtk_statusbar_push(GTK_STATUSBAR(self.status_bar), slimp->player->status_bar_id, slimp->toplay->uri);
	
	//Create the box
	self.box = gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(self.button), self.button_label);
	gtk_box_pack_start(GTK_BOX(self.box), GTK_WIDGET(self.button), FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(self.box), GTK_WIDGET(self.time_label), FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(self.box), GTK_WIDGET(self.scale), TRUE, TRUE, 0);
	gtk_box_pack_end(GTK_BOX(self.box), GTK_WIDGET(self.volume_button), FALSE, FALSE, 0);
	
	return &self;
}
